
(* mutable priority queues indexed by integers *)

(* FIXME this is an inefficient implementation! *)
structure PQueueList :> PQUEUE =
struct
    type pqueue = (int * (int * int)) list ref

    fun empty () = ref nil

    fun insert (r as ref l) n a =
	let
	    fun is nil = [(n,a)]
	      | is (l as ((m,b)::rest)) = 
		if n < m then (n,a)::l
		else (m,b)::is rest

(*	    val _ = print ("insert: queue size is " ^ Int.toString (length l) ^ "\n") *)
	in
	    r := is l
	end

    fun remlowest (r as ref ((_,h)::t)) = (r := t ; SOME h)
      | remlowest (ref nil) = NONE

    fun show _ = print "Unimplemented.\n"

end