signature LSOCKET =
sig

    type socket
    type listener
    exception Socket of string

    val send : socket -> string -> unit
    (* no newline *)
    val sendraw : socket -> string -> unit
    val recv : socket -> string
	
    val connect : string -> int -> socket
    val listen : int -> listener

    (* blocks until someone joins! *)
    val accept : listener -> socket

    val hangup : socket -> unit

end

